unit EventFilterHookU;

interface

uses
  Qt,
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtonEx, QExtCtrls, QComCtrls;

type
  TForm1 = class(TForm)
    Lst: TListView;
    Panel1: TPanel;
    chkWndProcHooked: TCheckBox;
    ButtonEx1: TButtonEx;
    procedure chkWndProcHookedClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FBtnHook: QButton_hookH;
    function NewBtnEventFilter(Sender: QObjectH; Event: QEventH): Boolean; cdecl;
  public
    procedure SetNewBtnEventFilter(Enable: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

uses
  EventTypes;

procedure TForm1.chkWndProcHookedClick(Sender: TObject);
begin
  SetNewBtnEventFilter(chkWndProcHooked.Checked);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SetNewBtnEventFilter(False);
end;

procedure TForm1.SetNewBtnEventFilter(Enable: Boolean);
var
  Method: TMethod;
begin
  if Enabled then
  begin
    FBtnHook := QButton_hook_create(ButtonEx1.Handle);
    TEventFilterMethod(Method) := NewBtnEventFilter;
    Qt_hook_hook_events(FBtnHook, Method);
  end
  else
    FBtnHook.Free
end;

function TForm1.NewBtnEventFilter(Sender: QObjectH;
  Event: QEventH): Boolean;
var
  Item: TListItem;
begin
  //Make new list view item
  Item := Lst.Items.Add;
  //Set up new list view item with message description
  Item.Caption := EventToStr(Event);
  Item.SubItems.Add(FormatDateTime('h:nn:ss.zzz', Time));
  Item.Selected := True;
  Item.Focused := True;
  Item.MakeVisible(False);

  //Return True if you want to hide the event
  Result := False;
end;

end.
