unit EventFilterTraceAndSignalSlotU;

interface

uses
  Qt,
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtonEx2, QExtCtrls, QComCtrls;

type
  TForm1 = class(TForm)
    Lst: TListView;
    Panel1: TPanel;
    chkWndProcHooked: TCheckBox;
    ButtonEx2: TButtonEx2;
    procedure chkWndProcHookedClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonEx2QtEvent(Sender: TComponent; Widget: QObjectH;
      Event: QEventH);
    procedure ButtonEx2ClickSignal(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

uses
  EventTypes;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ButtonEx2.OnQtEvent := nil;
end;

procedure TForm1.chkWndProcHookedClick(Sender: TObject);
begin
  if chkWndProcHooked.Checked then
    ButtonEx2.OnQtEvent := ButtonEx2QtEvent
  else
    ButtonEx2.OnQtEvent := nil;
end;

procedure TForm1.ButtonEx2QtEvent(Sender: TComponent; Widget: QObjectH;
  Event: QEventH);
var
  Item: TListItem;
begin
  Item := Lst.Items.Add;
  Item.Caption := EventToStr(Event);
  Item.SubItems.Add(FormatDateTime('h:nn:ss.zzz', Time));
  Item.Selected := True;
  Item.Focused := True;
  Item.MakeVisible(False)
end;

procedure TForm1.ButtonEx2ClickSignal(Sender: TObject);
begin
  ShowMessage('The button emitted a clicked signal')
end;

end.
