unit EventFilterTraceU;

interface

uses
  Qt,
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtonEx, QExtCtrls, QComCtrls;

type
  TForm1 = class(TForm)
    Lst: TListView;
    Panel1: TPanel;
    chkWndProcHooked: TCheckBox;
    ButtonEx1: TButtonEx;
    procedure chkWndProcHookedClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonEx1QtEvent(Sender: TComponent; Widget: QObjectH;
      Event: QEventH);
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

uses
  EventTypes;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ButtonEx1.OnQtEvent := nil;
end;

procedure TForm1.chkWndProcHookedClick(Sender: TObject);
begin
  if chkWndProcHooked.Checked then
    ButtonEx1.OnQtEvent := ButtonEx1QtEvent
  else
    ButtonEx1.OnQtEvent := nil;
end;

procedure TForm1.ButtonEx1QtEvent(Sender: TComponent; Widget: QObjectH;
  Event: QEventH);
var
  Item: TListItem;
begin
  Item := Lst.Items.Add;
  Item.Caption := EventToStr(Event);
  Item.SubItems.Add(FormatDateTime('h:nn:ss.zzz', Time));
  Item.Selected := True;
  Item.Focused := True;
  Item.MakeVisible(False)
end;

end.
