unit MessageIDs;

interface

function MsgIDToStr(MsgID: Word): String;

implementation

uses
  Messages, SysUtils, Controls;

type
  TMessageID = record
    MsgID: Word;
    MsgDesc: String
  end;

const
  Messages: array[0..433] of TMessageID =
  (
    (MsgID:    WM_NULL { $0000 };
     MsgDesc: 'WM_NULL'),
    (MsgID:    WM_CREATE { $0001 };
     MsgDesc: 'WM_CREATE'),
    (MsgID:    WM_DESTROY { $0002 };
     MsgDesc: 'WM_DESTROY'),
    (MsgID:    WM_MOVE { $0003 };
     MsgDesc: 'WM_MOVE'),
    (MsgID:    WM_SIZE { $0005 };
     MsgDesc: 'WM_SIZE'),
    (MsgID:    WM_ACTIVATE { $0006 };
     MsgDesc: 'WM_ACTIVATE'),
    (MsgID:    WM_SETFOCUS { $0007 };
     MsgDesc: 'WM_SETFOCUS'),
    (MsgID:    WM_KILLFOCUS { $0008 };
     MsgDesc: 'WM_KILLFOCUS'),
    (MsgID:    WM_ENABLE { $000A };
     MsgDesc: 'WM_ENABLE'),
    (MsgID:    WM_SETREDRAW { $000B };
     MsgDesc: 'WM_SETREDRAW'),
    (MsgID:    WM_SETTEXT { $000C };
     MsgDesc: 'WM_SETTEXT'),
    (MsgID:    WM_GETTEXT { $000D };
     MsgDesc: 'WM_GETTEXT'),
    (MsgID:    WM_GETTEXTLENGTH { $000E };
     MsgDesc: 'WM_GETTEXTLENGTH'),
    (MsgID:    WM_PAINT { $000F };
     MsgDesc: 'WM_PAINT'),
    (MsgID:    WM_CLOSE { $0010 };
     MsgDesc: 'WM_CLOSE'),
    (MsgID:    WM_QUERYENDSESSION { $0011 };
     MsgDesc: 'WM_QUERYENDSESSION'),
    (MsgID:    WM_QUIT { $0012 };
     MsgDesc: 'WM_QUIT'),
    (MsgID:    WM_QUERYOPEN { $0013 };
     MsgDesc: 'WM_QUERYOPEN'),
    (MsgID:    WM_ERASEBKGND { $0014 };
     MsgDesc: 'WM_ERASEBKGND'),
    (MsgID:    WM_SYSCOLORCHANGE { $0015 };
     MsgDesc: 'WM_SYSCOLORCHANGE'),
    (MsgID:    WM_ENDSESSION { $0016 };
     MsgDesc: 'WM_ENDSESSION'),
    (MsgID:    WM_SYSTEMERROR { $0017 };
     MsgDesc: 'WM_SYSTEMERROR'),
    (MsgID:    WM_SHOWWINDOW { $0018 };
     MsgDesc: 'WM_SHOWWINDOW'),
    (MsgID:    WM_CTLCOLOR { $0019 };
     MsgDesc: 'WM_CTLCOLOR'),
    (MsgID:    WM_WININICHANGE { $001A };
     MsgDesc: 'WM_WININICHANGE' {WM_SETTINGCHANGE}),
    (MsgID:    WM_DEVMODECHANGE { $001B };
     MsgDesc: 'WM_DEVMODECHANGE'),
    (MsgID:    WM_ACTIVATEAPP { $001C };
     MsgDesc: 'WM_ACTIVATEAPP'),
    (MsgID:    WM_FONTCHANGE { $001D };
     MsgDesc: 'WM_FONTCHANGE'),
    (MsgID:    WM_TIMECHANGE { $001E };
     MsgDesc: 'WM_TIMECHANGE'),
    (MsgID:    WM_CANCELMODE { $001F };
     MsgDesc: 'WM_CANCELMODE'),
    (MsgID:    WM_SETCURSOR { $0020 };
     MsgDesc: 'WM_SETCURSOR'),
    (MsgID:    WM_MOUSEACTIVATE { $0021 };
     MsgDesc: 'WM_MOUSEACTIVATE'),
    (MsgID:    WM_CHILDACTIVATE { $0022 };
     MsgDesc: 'WM_CHILDACTIVATE'),
    (MsgID:    WM_QUEUESYNC { $0023 };
     MsgDesc: 'WM_QUEUESYNC'),
    (MsgID:    WM_GETMINMAXINFO { $0024 };
     MsgDesc: 'WM_GETMINMAXINFO'),
    (MsgID:    WM_PAINTICON { $0026 };
     MsgDesc: 'WM_PAINTICON'),
    (MsgID:    WM_ICONERASEBKGND { $0027 };
     MsgDesc: 'WM_ICONERASEBKGND'),
    (MsgID:    WM_NEXTDLGCTL { $0028 };
     MsgDesc: 'WM_NEXTDLGCTL'),
    (MsgID:    WM_SPOOLERSTATUS { $002A };
     MsgDesc: 'WM_SPOOLERSTATUS'),
    (MsgID:    WM_DRAWITEM { $002B };
     MsgDesc: 'WM_DRAWITEM'),
    (MsgID:    WM_MEASUREITEM { $002C };
     MsgDesc: 'WM_MEASUREITEM'),
    (MsgID:    WM_DELETEITEM { $002D };
     MsgDesc: 'WM_DELETEITEM'),
    (MsgID:    WM_VKEYTOITEM { $002E };
     MsgDesc: 'WM_VKEYTOITEM'),
    (MsgID:    WM_CHARTOITEM { $002F };
     MsgDesc: 'WM_CHARTOITEM'),
    (MsgID:    WM_SETFONT { $0030 };
     MsgDesc: 'WM_SETFONT'),
    (MsgID:    WM_GETFONT { $0031 };
     MsgDesc: 'WM_GETFONT'),
    (MsgID:    WM_SETHOTKEY { $0032 };
     MsgDesc: 'WM_SETHOTKEY'),
    (MsgID:    WM_GETHOTKEY { $0033 };
     MsgDesc: 'WM_GETHOTKEY'),
    (MsgID:    WM_QUERYDRAGICON { $0037 };
     MsgDesc: 'WM_QUERYDRAGICON'),
    (MsgID:    WM_COMPAREITEM { $0039 };
     MsgDesc: 'WM_COMPAREITEM'),
    (MsgID:    WM_GETOBJECT { $003D };
     MsgDesc: 'WM_GETOBJECT'),
    (MsgID:    WM_COMPACTING { $0041 };
     MsgDesc: 'WM_COMPACTING'),
    (MsgID:    WM_COMMNOTIFY { $0044 };
     MsgDesc: 'WM_COMMNOTIFY'),
    (MsgID:    WM_WINDOWPOSCHANGING { $0046 };
     MsgDesc: 'WM_WINDOWPOSCHANGING'),
    (MsgID:    WM_WINDOWPOSCHANGED { $0047 };
     MsgDesc: 'WM_WINDOWPOSCHANGED'),
    (MsgID:    WM_POWER { $0048 };
     MsgDesc: 'WM_POWER'),
    (MsgID:    WM_COPYDATA { $004A };
     MsgDesc: 'WM_COPYDATA'),
    (MsgID:    WM_CANCELJOURNAL { $004B };
     MsgDesc: 'WM_CANCELJOURNAL'),
    (MsgID:    WM_NOTIFY { $004E };
     MsgDesc: 'WM_NOTIFY'),
    (MsgID:    WM_INPUTLANGCHANGEREQUEST { $0050 };
     MsgDesc: 'WM_INPUTLANGCHANGEREQUEST'),
    (MsgID:    WM_INPUTLANGCHANGE { $0051 };
     MsgDesc: 'WM_INPUTLANGCHANGE'),
    (MsgID:    WM_TCARD { $0052 };
     MsgDesc: 'WM_TCARD'),
    (MsgID:    WM_HELP { $0053 };
     MsgDesc: 'WM_HELP'),
    (MsgID:    WM_USERCHANGED { $0054 };
     MsgDesc: 'WM_USERCHANGED'),
    (MsgID:    WM_NOTIFYFORMAT { $0055 };
     MsgDesc: 'WM_NOTIFYFORMAT'),
    (MsgID:    WM_CONTEXTMENU { $007B };
     MsgDesc: 'WM_CONTEXTMENU'),
    (MsgID:    WM_STYLECHANGING { $007C };
     MsgDesc: 'WM_STYLECHANGING'),
    (MsgID:    WM_STYLECHANGED { $007D };
     MsgDesc: 'WM_STYLECHANGED'),
    (MsgID:    WM_DISPLAYCHANGE { $007E };
     MsgDesc: 'WM_DISPLAYCHANGE'),
    (MsgID:    WM_GETICON { $007F };
     MsgDesc: 'WM_GETICON'),
    (MsgID:    WM_SETICON { $0080 };
     MsgDesc: 'WM_SETICON'),
    (MsgID:    WM_NCCREATE { $0081 };
     MsgDesc: 'WM_NCCREATE'),
    (MsgID:    WM_NCDESTROY { $0082 };
     MsgDesc: 'WM_NCDESTROY'),
    (MsgID:    WM_NCCALCSIZE { $0083 };
     MsgDesc: 'WM_NCCALCSIZE'),
    (MsgID:    WM_NCHITTEST { $0084 };
     MsgDesc: 'WM_NCHITTEST'),
    (MsgID:    WM_NCPAINT { $0085 };
     MsgDesc: 'WM_NCPAINT'),
    (MsgID:    WM_NCACTIVATE { $0086 };
     MsgDesc: 'WM_NCACTIVATE'),
    (MsgID:    WM_GETDLGCODE { $0087 };
     MsgDesc: 'WM_GETDLGCODE'),
    (MsgID:    WM_NCMOUSEMOVE { $00A0 };
     MsgDesc: 'WM_NCMOUSEMOVE'),
    (MsgID:    WM_NCLBUTTONDOWN { $00A1 };
     MsgDesc: 'WM_NCLBUTTONDOWN'),
    (MsgID:    WM_NCLBUTTONUP { $00A2 };
     MsgDesc: 'WM_NCLBUTTONUP'),
    (MsgID:    WM_NCLBUTTONDBLCLK { $00A3 };
     MsgDesc: 'WM_NCLBUTTONDBLCLK'),
    (MsgID:    WM_NCRBUTTONDOWN { $00A4 };
     MsgDesc: 'WM_NCRBUTTONDOWN'),
    (MsgID:    WM_NCRBUTTONUP { $00A5 };
     MsgDesc: 'WM_NCRBUTTONUP'),
    (MsgID:    WM_NCRBUTTONDBLCLK { $00A6 };
     MsgDesc: 'WM_NCRBUTTONDBLCLK'),
    (MsgID:    WM_NCMBUTTONDOWN { $00A7 };
     MsgDesc: 'WM_NCMBUTTONDOWN'),
    (MsgID:    WM_NCMBUTTONUP { $00A8 };
     MsgDesc: 'WM_NCMBUTTONUP'),
    (MsgID:    WM_NCMBUTTONDBLCLK { $00A9 };
     MsgDesc: 'WM_NCMBUTTONDBLCLK'),
    (MsgID:    EM_GETSEL { $00B0 };
     MsgDesc: 'EM_GETSEL'),
    (MsgID:    EM_SETSEL { $00B1 };
     MsgDesc: 'EM_SETSEL'),
    (MsgID:    EM_GETRECT { $00B2 };
     MsgDesc: 'EM_GETRECT'),
    (MsgID:    EM_SETRECT { $00B3 };
     MsgDesc: 'EM_SETRECT'),
    (MsgID:    EM_SETRECTNP { $00B4 };
     MsgDesc: 'EM_SETRECTNP'),
    (MsgID:    EM_SCROLL { $00B5 };
     MsgDesc: 'EM_SCROLL'),
    (MsgID:    EM_LINESCROLL { $00B6 };
     MsgDesc: 'EM_LINESCROLL'),
    (MsgID:    EM_SCROLLCARET { $00B7 };
     MsgDesc: 'EM_SCROLLCARET'),
    (MsgID:    EM_GETMODIFY { $00B8 };
     MsgDesc: 'EM_GETMODIFY'),
    (MsgID:    EM_SETMODIFY { $00B9 };
     MsgDesc: 'EM_SETMODIFY'),
    (MsgID:    EM_GETLINECOUNT { $00BA };
     MsgDesc: 'EM_GETLINECOUNT'),
    (MsgID:    EM_LINEINDEX { $00BB };
     MsgDesc: 'EM_LINEINDEX'),
    (MsgID:    EM_SETHANDLE { $00BC };
     MsgDesc: 'EM_SETHANDLE'),
    (MsgID:    EM_GETHANDLE { $00BD };
     MsgDesc: 'EM_GETHANDLE'),
    (MsgID:    EM_GETTHUMB { $00BE };
     MsgDesc: 'EM_GETTHUMB'),
    (MsgID:    EM_LINELENGTH { $00C1 };
     MsgDesc: 'EM_LINELENGTH'),
    (MsgID:    EM_REPLACESEL { $00C2 };
     MsgDesc: 'EM_REPLACESEL'),
    (MsgID:    EM_GETLINE { $00C4 };
     MsgDesc: 'EM_GETLINE'),
    (MsgID:    EM_LIMITTEXT { $00C5 };
     MsgDesc: 'EM_LIMITTEXT' {EM_SETLIMITTEXT}),
    (MsgID:    EM_CANUNDO { $00C6 };
     MsgDesc: 'EM_CANUNDO'),
    (MsgID:    EM_UNDO { $00C7 };
     MsgDesc: 'EM_UNDO'),
    (MsgID:    EM_FMTLINES { $00C8 };
     MsgDesc: 'EM_FMTLINES'),
    (MsgID:    EM_LINEFROMCHAR { $00C9 };
     MsgDesc: 'EM_LINEFROMCHAR'),
    (MsgID:    EM_SETTABSTOPS { $00CB };
     MsgDesc: 'EM_SETTABSTOPS'),
    (MsgID:    EM_SETPASSWORDCHAR { $00CC };
     MsgDesc: 'EM_SETPASSWORDCHAR'),
    (MsgID:    EM_EMPTYUNDOBUFFER { $00CD };
     MsgDesc: 'EM_EMPTYUNDOBUFFER'),
    (MsgID:    EM_GETFIRSTVISIBLELINE { $00CE };
     MsgDesc: 'EM_GETFIRSTVISIBLELINE'),
    (MsgID:    EM_SETREADONLY { $00CF };
     MsgDesc: 'EM_SETREADONLY'),
    (MsgID:    EM_SETWORDBREAKPROC { $00D0 };
     MsgDesc: 'EM_SETWORDBREAKPROC'),
    (MsgID:    EM_GETWORDBREAKPROC { $00D1 };
     MsgDesc: 'EM_GETWORDBREAKPROC'),
    (MsgID:    EM_GETPASSWORDCHAR { $00D2 };
     MsgDesc: 'EM_GETPASSWORDCHAR'),
    (MsgID:    EM_SETMARGINS { $00D3 };
     MsgDesc: 'EM_SETMARGINS'),
    (MsgID:    EM_GETMARGINS { $00D4 };
     MsgDesc: 'EM_GETMARGINS'),
    (MsgID:    EM_GETLIMITTEXT { $00D5 };
     MsgDesc: 'EM_GETLIMITTEXT'),
    (MsgID:    EM_POSFROMCHAR { $00D6 };
     MsgDesc: 'EM_POSFROMCHAR'),
    (MsgID:    EM_CHARFROMPOS { $00D7 };
     MsgDesc: 'EM_CHARFROMPOS'),
    (MsgID:    EM_SETIMESTATUS { $00D8 };
     MsgDesc: 'EM_SETIMESTATUS'),
    (MsgID:    EM_GETIMESTATUS { $00D9 };
     MsgDesc: 'EM_GETIMESTATUS'),
    (MsgID:    SBM_SETPOS { $00E0 };
     MsgDesc: 'SBM_SETPOS'),
    (MsgID:    SBM_GETPOS { $00E1 };
     MsgDesc: 'SBM_GETPOS'),
    (MsgID:    SBM_SETRANGE { $00E2 };
     MsgDesc: 'SBM_SETRANGE'),
    (MsgID:    SBM_GETRANGE { $00E3 };
     MsgDesc: 'SBM_GETRANGE'),
    (MsgID:    SBM_ENABLE_ARROWS { $00E4 };
     MsgDesc: 'SBM_ENABLE_ARROWS'),
    (MsgID:    SBM_SETRANGEREDRAW { $00E6 };
     MsgDesc: 'SBM_SETRANGEREDRAW'),
    (MsgID:    SBM_SETSCROLLINFO { $00E9 };
     MsgDesc: 'SBM_SETSCROLLINFO'),
    (MsgID:    SBM_GETSCROLLINFO { $00EA };
     MsgDesc: 'SBM_GETSCROLLINFO'),
    (MsgID:    BM_GETCHECK { $00F0 };
     MsgDesc: 'BM_GETCHECK'),
    (MsgID:    BM_SETCHECK { $00F1 };
     MsgDesc: 'BM_SETCHECK'),
    (MsgID:    BM_GETSTATE { $00F2 };
     MsgDesc: 'BM_GETSTATE'),
    (MsgID:    BM_SETSTATE { $00F3 };
     MsgDesc: 'BM_SETSTATE'),
    (MsgID:    BM_SETSTYLE { $00F4 };
     MsgDesc: 'BM_SETSTYLE'),
    (MsgID:    BM_CLICK { $00F5 };
     MsgDesc: 'BM_CLICK'),
    (MsgID:    BM_GETIMAGE { $00F6 };
     MsgDesc: 'BM_GETIMAGE'),
    (MsgID:    BM_SETIMAGE { $00F7 };
     MsgDesc: 'BM_SETIMAGE'),
    (MsgID:    WM_KEYDOWN { $0100 };
     MsgDesc: 'WM_KEYDOWN' {WM_KEYFIRST}),
    (MsgID:    WM_KEYUP { $0101 };
     MsgDesc: 'WM_KEYUP'),
    (MsgID:    WM_CHAR { $0102 };
     MsgDesc: 'WM_CHAR'),
    (MsgID:    WM_DEADCHAR { $0103 };
     MsgDesc: 'WM_DEADCHAR'),
    (MsgID:    WM_SYSKEYDOWN { $0104 };
     MsgDesc: 'WM_SYSKEYDOWN'),
    (MsgID:    WM_SYSKEYUP { $0105 };
     MsgDesc: 'WM_SYSKEYUP'),
    (MsgID:    WM_SYSCHAR { $0106 };
     MsgDesc: 'WM_SYSCHAR'),
    (MsgID:    WM_SYSDEADCHAR { $0107 };
     MsgDesc: 'WM_SYSDEADCHAR'),
    (MsgID:    WM_KEYLAST { $0108 };
     MsgDesc: 'WM_KEYLAST'),
    (MsgID:    WM_IME_STARTCOMPOSITION { $010D };
     MsgDesc: 'WM_IME_STARTCOMPOSITION'),
    (MsgID:    WM_IME_ENDCOMPOSITION { $010E };
     MsgDesc: 'WM_IME_ENDCOMPOSITION'),
    (MsgID:    WM_IME_COMPOSITION { $010F };
     MsgDesc: 'WM_IME_COMPOSITION' {WM_IME_KEYLAST}),
    (MsgID:    WM_INITDIALOG { $0110 };
     MsgDesc: 'WM_INITDIALOG'),
    (MsgID:    WM_COMMAND { $0111 };
     MsgDesc: 'WM_COMMAND'),
    (MsgID:    WM_SYSCOMMAND { $0112 };
     MsgDesc: 'WM_SYSCOMMAND'),
    (MsgID:    WM_TIMER { $0113 };
     MsgDesc: 'WM_TIMER'),
    (MsgID:    WM_HSCROLL { $0114 };
     MsgDesc: 'WM_HSCROLL'),
    (MsgID:    WM_VSCROLL { $0115 };
     MsgDesc: 'WM_VSCROLL'),
    (MsgID:    WM_INITMENU { $0116 };
     MsgDesc: 'WM_INITMENU'),
    (MsgID:    WM_INITMENUPOPUP { $0117 };
     MsgDesc: 'WM_INITMENUPOPUP'),
    (MsgID:    WM_MENUSELECT { $011F };
     MsgDesc: 'WM_MENUSELECT'),
    (MsgID:    WM_MENUCHAR { $0120 };
     MsgDesc: 'WM_MENUCHAR'),
    (MsgID:    WM_ENTERIDLE { $0121 };
     MsgDesc: 'WM_ENTERIDLE'),
    (MsgID:    WM_MENURBUTTONUP { $0122 };
     MsgDesc: 'WM_MENURBUTTONUP'),
    (MsgID:    WM_MENUDRAG { $0123 };
     MsgDesc: 'WM_MENUDRAG'),
    (MsgID:    WM_MENUGETOBJECT { $0124 };
     MsgDesc: 'WM_MENUGETOBJECT'),
    (MsgID:    WM_UNINITMENUPOPUP { $0125 };
     MsgDesc: 'WM_UNINITMENUPOPUP'),
    (MsgID:    WM_MENUCOMMAND { $0126 };
     MsgDesc: 'WM_MENUCOMMAND'),
    (MsgID:    WM_CHANGEUISTATE { $0127 };
     MsgDesc: 'WM_CHANGEUISTATE'),
    (MsgID:    WM_UPDATEUISTATE { $0128 };
     MsgDesc: 'WM_UPDATEUISTATE'),
    (MsgID:    WM_QUERYUISTATE { $0129 };
     MsgDesc: 'WM_QUERYUISTATE'),
    (MsgID:    WM_CTLCOLORMSGBOX { $0132 };
     MsgDesc: 'WM_CTLCOLORMSGBOX'),
    (MsgID:    WM_CTLCOLOREDIT { $0133 };
     MsgDesc: 'WM_CTLCOLOREDIT'),
    (MsgID:    WM_CTLCOLORLISTBOX { $0134 };
     MsgDesc: 'WM_CTLCOLORLISTBOX'),
    (MsgID:    WM_CTLCOLORBTN { $0135 };
     MsgDesc: 'WM_CTLCOLORBTN'),
    (MsgID:    WM_CTLCOLORDLG { $0136 };
     MsgDesc: 'WM_CTLCOLORDLG'),
    (MsgID:    WM_CTLCOLORSCROLLBAR { $0137 };
     MsgDesc: 'WM_CTLCOLORSCROLLBAR'),
    (MsgID:    WM_CTLCOLORSTATIC { $0138 };
     MsgDesc: 'WM_CTLCOLORSTATIC'),
    (MsgID:    CB_GETEDITSEL { $0140 };
     MsgDesc: 'CB_GETEDITSEL'),
    (MsgID:    CB_LIMITTEXT { $0141 };
     MsgDesc: 'CB_LIMITTEXT'),
    (MsgID:    CB_SETEDITSEL { $0142 };
     MsgDesc: 'CB_SETEDITSEL'),
    (MsgID:    CB_ADDSTRING { $0143 };
     MsgDesc: 'CB_ADDSTRING'),
    (MsgID:    CB_DELETESTRING { $0144 };
     MsgDesc: 'CB_DELETESTRING'),
    (MsgID:    CB_DIR { $0145 };
     MsgDesc: 'CB_DIR'),
    (MsgID:    CB_GETCOUNT { $0146 };
     MsgDesc: 'CB_GETCOUNT'),
    (MsgID:    CB_GETCURSEL { $0147 };
     MsgDesc: 'CB_GETCURSEL'),
    (MsgID:    CB_GETLBTEXT { $0148 };
     MsgDesc: 'CB_GETLBTEXT'),
    (MsgID:    CB_GETLBTEXTLEN { $0149 };
     MsgDesc: 'CB_GETLBTEXTLEN'),
    (MsgID:    CB_INSERTSTRING { $014A };
     MsgDesc: 'CB_INSERTSTRING'),
    (MsgID:    CB_RESETCONTENT { $014B };
     MsgDesc: 'CB_RESETCONTENT'),
    (MsgID:    CB_FINDSTRING { $014C };
     MsgDesc: 'CB_FINDSTRING'),
    (MsgID:    CB_SELECTSTRING { $014D };
     MsgDesc: 'CB_SELECTSTRING'),
    (MsgID:    CB_SETCURSEL { $014E };
     MsgDesc: 'CB_SETCURSEL'),
    (MsgID:    CB_SHOWDROPDOWN { $014F };
     MsgDesc: 'CB_SHOWDROPDOWN'),
    (MsgID:    CB_GETITEMDATA { $0150 };
     MsgDesc: 'CB_GETITEMDATA'),
    (MsgID:    CB_SETITEMDATA { $0151 };
     MsgDesc: 'CB_SETITEMDATA'),
    (MsgID:    CB_GETDROPPEDCONTROLRECT { $0152 };
     MsgDesc: 'CB_GETDROPPEDCONTROLRECT'),
    (MsgID:    CB_SETITEMHEIGHT { $0153 };
     MsgDesc: 'CB_SETITEMHEIGHT'),
    (MsgID:    CB_GETITEMHEIGHT { $0154 };
     MsgDesc: 'CB_GETITEMHEIGHT'),
    (MsgID:    CB_SETEXTENDEDUI { $0155 };
     MsgDesc: 'CB_SETEXTENDEDUI'),
    (MsgID:    CB_GETEXTENDEDUI { $0156 };
     MsgDesc: 'CB_GETEXTENDEDUI'),
    (MsgID:    CB_GETDROPPEDSTATE { $0157 };
     MsgDesc: 'CB_GETDROPPEDSTATE'),
    (MsgID:    CB_FINDSTRINGEXACT { $0158 };
     MsgDesc: 'CB_FINDSTRINGEXACT'),
    (MsgID:    CB_SETLOCALE { $0159 };
     MsgDesc: 'CB_SETLOCALE'),
    (MsgID:    CB_GETLOCALE { $015A };
     MsgDesc: 'CB_GETLOCALE'),
    (MsgID:    CB_GETTOPINDEX { $015B };
     MsgDesc: 'CB_GETTOPINDEX'),
    (MsgID:    CB_SETTOPINDEX { $015C };
     MsgDesc: 'CB_SETTOPINDEX'),
    (MsgID:    CB_GETHORIZONTALEXTENT { $015D };
     MsgDesc: 'CB_GETHORIZONTALEXTENT'),
    (MsgID:    CB_SETHORIZONTALEXTENT { $015E };
     MsgDesc: 'CB_SETHORIZONTALEXTENT'),
    (MsgID:    CB_GETDROPPEDWIDTH { $015F };
     MsgDesc: 'CB_GETDROPPEDWIDTH'),
    (MsgID:    CB_SETDROPPEDWIDTH { $0160 };
     MsgDesc: 'CB_SETDROPPEDWIDTH'),
    (MsgID:    CB_INITSTORAGE { $0161 };
     MsgDesc: 'CB_INITSTORAGE'),
    (MsgID:    CB_MSGMAX { $0162 };
     MsgDesc: 'CB_MSGMAX'),
    (MsgID:    LB_ADDSTRING { $0180 };
     MsgDesc: 'LB_ADDSTRING'),
    (MsgID:    LB_INSERTSTRING { $0181 };
     MsgDesc: 'LB_INSERTSTRING'),
    (MsgID:    LB_DELETESTRING { $0182 };
     MsgDesc: 'LB_DELETESTRING'),
    (MsgID:    LB_SELITEMRANGEEX { $0183 };
     MsgDesc: 'LB_SELITEMRANGEEX'),
    (MsgID:    LB_RESETCONTENT { $0184 };
     MsgDesc: 'LB_RESETCONTENT'),
    (MsgID:    LB_SETSEL { $0185 };
     MsgDesc: 'LB_SETSEL'),
    (MsgID:    LB_SETCURSEL { $0186 };
     MsgDesc: 'LB_SETCURSEL'),
    (MsgID:    LB_GETSEL { $0187 };
     MsgDesc: 'LB_GETSEL'),
    (MsgID:    LB_GETCURSEL { $0188 };
     MsgDesc: 'LB_GETCURSEL'),
    (MsgID:    LB_GETTEXT { $0189 };
     MsgDesc: 'LB_GETTEXT'),
    (MsgID:    LB_GETTEXTLEN { $018A };
     MsgDesc: 'LB_GETTEXTLEN'),
    (MsgID:    LB_GETCOUNT { $018B };
     MsgDesc: 'LB_GETCOUNT'),
    (MsgID:    LB_SELECTSTRING { $018C };
     MsgDesc: 'LB_SELECTSTRING'),
    (MsgID:    LB_DIR { $018D };
     MsgDesc: 'LB_DIR'),
    (MsgID:    LB_GETTOPINDEX { $018E };
     MsgDesc: 'LB_GETTOPINDEX'),
    (MsgID:    LB_FINDSTRING { $018F };
     MsgDesc: 'LB_FINDSTRING'),
    (MsgID:    LB_GETSELCOUNT { $0190 };
     MsgDesc: 'LB_GETSELCOUNT'),
    (MsgID:    LB_GETSELITEMS { $0191 };
     MsgDesc: 'LB_GETSELITEMS'),
    (MsgID:    LB_SETTABSTOPS { $0192 };
     MsgDesc: 'LB_SETTABSTOPS'),
    (MsgID:    LB_GETHORIZONTALEXTENT { $0193 };
     MsgDesc: 'LB_GETHORIZONTALEXTENT'),
    (MsgID:    LB_SETHORIZONTALEXTENT { $0194 };
     MsgDesc: 'LB_SETHORIZONTALEXTENT'),
    (MsgID:    LB_SETCOLUMNWIDTH { $0195 };
     MsgDesc: 'LB_SETCOLUMNWIDTH'),
    (MsgID:    LB_ADDFILE { $0196 };
     MsgDesc: 'LB_ADDFILE'),
    (MsgID:    LB_SETTOPINDEX { $0197 };
     MsgDesc: 'LB_SETTOPINDEX'),
    (MsgID:    LB_GETITEMRECT { $0198 };
     MsgDesc: 'LB_GETITEMRECT'),
    (MsgID:    LB_GETITEMDATA { $0199 };
     MsgDesc: 'LB_GETITEMDATA'),
    (MsgID:    LB_SETITEMDATA { $019A };
     MsgDesc: 'LB_SETITEMDATA'),
    (MsgID:    LB_SELITEMRANGE { $019B };
     MsgDesc: 'LB_SELITEMRANGE'),
    (MsgID:    LB_SETANCHORINDEX { $019C };
     MsgDesc: 'LB_SETANCHORINDEX'),
    (MsgID:    LB_GETANCHORINDEX { $019D };
     MsgDesc: 'LB_GETANCHORINDEX'),
    (MsgID:    LB_SETCARETINDEX { $019E };
     MsgDesc: 'LB_SETCARETINDEX'),
    (MsgID:    LB_GETCARETINDEX { $019F };
     MsgDesc: 'LB_GETCARETINDEX'),
    (MsgID:    LB_SETITEMHEIGHT { $01A0 };
     MsgDesc: 'LB_SETITEMHEIGHT'),
    (MsgID:    LB_GETITEMHEIGHT { $01A1 };
     MsgDesc: 'LB_GETITEMHEIGHT'),
    (MsgID:    LB_FINDSTRINGEXACT { $01A2 };
     MsgDesc: 'LB_FINDSTRINGEXACT'),
    (MsgID:    LB_SETLOCALE { $01A5 };
     MsgDesc: 'LB_SETLOCALE'),
    (MsgID:    LB_GETLOCALE { $01A6 };
     MsgDesc: 'LB_GETLOCALE'),
    (MsgID:    LB_SETCOUNT { $01A7 };
     MsgDesc: 'LB_SETCOUNT'),
    (MsgID:    LB_INITSTORAGE { $01A8 };
     MsgDesc: 'LB_INITSTORAGE'),
    (MsgID:    LB_ITEMFROMPOINT { $01A9 };
     MsgDesc: 'LB_ITEMFROMPOINT'),
    (MsgID:    LB_MSGMAX { $01B0 };
     MsgDesc: 'LB_MSGMAX'),
    (MsgID:    WM_MOUSEFIRST { $0200 };
     MsgDesc: 'WM_MOUSEFIRST'),
    (MsgID:    WM_MOUSEMOVE { $0200 };
     MsgDesc: 'WM_MOUSEMOVE'),
    (MsgID:    WM_LBUTTONDOWN { $0201 };
     MsgDesc: 'WM_LBUTTONDOWN'),
    (MsgID:    WM_LBUTTONUP { $0202 };
     MsgDesc: 'WM_LBUTTONUP'),
    (MsgID:    WM_LBUTTONDBLCLK { $0203 };
     MsgDesc: 'WM_LBUTTONDBLCLK'),
    (MsgID:    WM_RBUTTONDOWN { $0204 };
     MsgDesc: 'WM_RBUTTONDOWN'),
    (MsgID:    WM_RBUTTONUP { $0205 };
     MsgDesc: 'WM_RBUTTONUP'),
    (MsgID:    WM_RBUTTONDBLCLK { $0206 };
     MsgDesc: 'WM_RBUTTONDBLCLK'),
    (MsgID:    WM_MBUTTONDOWN { $0207 };
     MsgDesc: 'WM_MBUTTONDOWN'),
    (MsgID:    WM_MBUTTONUP { $0208 };
     MsgDesc: 'WM_MBUTTONUP'),
    (MsgID:    WM_MBUTTONDBLCLK { $0209 };
     MsgDesc: 'WM_MBUTTONDBLCLK'),
    (MsgID:    WM_MOUSEWHEEL { $020A };
     MsgDesc: 'WM_MOUSEWHEEL' {WM_MOUSELAST}),
    (MsgID:    WM_PARENTNOTIFY { $0210 };
     MsgDesc: 'WM_PARENTNOTIFY'),
    (MsgID:    WM_ENTERMENULOOP { $0211 };
     MsgDesc: 'WM_ENTERMENULOOP'),
    (MsgID:    WM_EXITMENULOOP { $0212 };
     MsgDesc: 'WM_EXITMENULOOP'),
    (MsgID:    WM_NEXTMENU { $0213 };
     MsgDesc: 'WM_NEXTMENU'),
    (MsgID:    WM_SIZING { $0214 };
     MsgDesc: 'WM_SIZING'),
    (MsgID:    WM_CAPTURECHANGED { $0215 };
     MsgDesc: 'WM_CAPTURECHANGED'),
    (MsgID:    WM_MOVING { $0216 };
     MsgDesc: 'WM_MOVING'),
    (MsgID:    WM_POWERBROADCAST { $0218 };
     MsgDesc: 'WM_POWERBROADCAST'),
    (MsgID:    WM_DEVICECHANGE { $0219 };
     MsgDesc: 'WM_DEVICECHANGE'),
    (MsgID:    WM_IME_SETCONTEXT { $0281 };
     MsgDesc: 'WM_IME_SETCONTEXT'),
    (MsgID:    WM_IME_NOTIFY { $0282 };
     MsgDesc: 'WM_IME_NOTIFY'),
    (MsgID:    WM_IME_CONTROL { $0283 };
     MsgDesc: 'WM_IME_CONTROL'),
    (MsgID:    WM_IME_COMPOSITIONFULL { $0284 };
     MsgDesc: 'WM_IME_COMPOSITIONFULL'),
    (MsgID:    WM_IME_SELECT { $0285 };
     MsgDesc: 'WM_IME_SELECT'),
    (MsgID:    WM_IME_CHAR { $0286 };
     MsgDesc: 'WM_IME_CHAR'),
    (MsgID:    WM_IME_REQUEST { $0288 };
     MsgDesc: 'WM_IME_REQUEST'),
    (MsgID:    WM_IME_KEYDOWN { $0290 };
     MsgDesc: 'WM_IME_KEYDOWN'),
    (MsgID:    WM_IME_KEYUP { $0291 };
     MsgDesc: 'WM_IME_KEYUP'),
    (MsgID:    WM_MDICREATE { $0220 };
     MsgDesc: 'WM_MDICREATE'),
    (MsgID:    WM_MDIDESTROY { $0221 };
     MsgDesc: 'WM_MDIDESTROY'),
    (MsgID:    WM_MDIACTIVATE { $0222 };
     MsgDesc: 'WM_MDIACTIVATE'),
    (MsgID:    WM_MDIRESTORE { $0223 };
     MsgDesc: 'WM_MDIRESTORE'),
    (MsgID:    WM_MDINEXT { $0224 };
     MsgDesc: 'WM_MDINEXT'),
    (MsgID:    WM_MDIMAXIMIZE { $0225 };
     MsgDesc: 'WM_MDIMAXIMIZE'),
    (MsgID:    WM_MDITILE { $0226 };
     MsgDesc: 'WM_MDITILE'),
    (MsgID:    WM_MDICASCADE { $0227 };
     MsgDesc: 'WM_MDICASCADE'),
    (MsgID:    WM_MDIICONARRANGE { $0228 };
     MsgDesc: 'WM_MDIICONARRANGE'),
    (MsgID:    WM_MDIGETACTIVE { $0229 };
     MsgDesc: 'WM_MDIGETACTIVE'),
    (MsgID:    WM_MDISETMENU { $0230 };
     MsgDesc: 'WM_MDISETMENU'),
    (MsgID:    WM_ENTERSIZEMOVE { $0231 };
     MsgDesc: 'WM_ENTERSIZEMOVE'),
    (MsgID:    WM_EXITSIZEMOVE { $0232 };
     MsgDesc: 'WM_EXITSIZEMOVE'),
    (MsgID:    WM_DROPFILES { $0233 };
     MsgDesc: 'WM_DROPFILES'),
    (MsgID:    WM_MDIREFRESHMENU { $0234 };
     MsgDesc: 'WM_MDIREFRESHMENU'),
    (MsgID:    WM_MOUSEHOVER { $02A1 };
     MsgDesc: 'WM_MOUSEHOVER'),
    (MsgID:    WM_MOUSELEAVE { $02A3 };
     MsgDesc: 'WM_MOUSELEAVE'),
    (MsgID:    WM_CUT { $0300 };
     MsgDesc: 'WM_CUT'),
    (MsgID:    WM_COPY { $0301 };
     MsgDesc: 'WM_COPY'),
    (MsgID:    WM_PASTE { $0302 };
     MsgDesc: 'WM_PASTE'),
    (MsgID:    WM_CLEAR { $0303 };
     MsgDesc: 'WM_CLEAR'),
    (MsgID:    WM_UNDO { $0304 };
     MsgDesc: 'WM_UNDO'),
    (MsgID:    WM_RENDERFORMAT { $0305 };
     MsgDesc: 'WM_RENDERFORMAT'),
    (MsgID:    WM_RENDERALLFORMATS { $0306 };
     MsgDesc: 'WM_RENDERALLFORMATS'),
    (MsgID:    WM_DESTROYCLIPBOARD { $0307 };
     MsgDesc: 'WM_DESTROYCLIPBOARD'),
    (MsgID:    WM_DRAWCLIPBOARD { $0308 };
     MsgDesc: 'WM_DRAWCLIPBOARD'),
    (MsgID:    WM_PAINTCLIPBOARD { $0309 };
     MsgDesc: 'WM_PAINTCLIPBOARD'),
    (MsgID:    WM_VSCROLLCLIPBOARD { $030A };
     MsgDesc: 'WM_VSCROLLCLIPBOARD'),
    (MsgID:    WM_SIZECLIPBOARD { $030B };
     MsgDesc: 'WM_SIZECLIPBOARD'),
    (MsgID:    WM_ASKCBFORMATNAME { $030C };
     MsgDesc: 'WM_ASKCBFORMATNAME'),
    (MsgID:    WM_CHANGECBCHAIN { $030D };
     MsgDesc: 'WM_CHANGECBCHAIN'),
    (MsgID:    WM_HSCROLLCLIPBOARD { $030E };
     MsgDesc: 'WM_HSCROLLCLIPBOARD'),
    (MsgID:    WM_QUERYNEWPALETTE { $030F };
     MsgDesc: 'WM_QUERYNEWPALETTE'),
    (MsgID:    WM_PALETTEISCHANGING { $0310 };
     MsgDesc: 'WM_PALETTEISCHANGING'),
    (MsgID:    WM_PALETTECHANGED { $0311 };
     MsgDesc: 'WM_PALETTECHANGED'),
    (MsgID:    WM_HOTKEY { $0312 };
     MsgDesc: 'WM_HOTKEY'),
    (MsgID:    WM_PRINT { $0317 };
     MsgDesc: 'WM_PRINT'),
    (MsgID:    WM_PRINTCLIENT { $0318 };
     MsgDesc: 'WM_PRINTCLIENT'),
    (MsgID:    WM_HANDHELDFIRST { $0358 };
     MsgDesc: 'WM_HANDHELDFIRST'),
    (MsgID:    WM_HANDHELDLAST { $035F };
     MsgDesc: 'WM_HANDHELDLAST'),
    (MsgID:    WM_PENWINFIRST { $0380 };
     MsgDesc: 'WM_PENWINFIRST'),
    (MsgID:    WM_PENWINLAST { $038F };
     MsgDesc: 'WM_PENWINLAST'),
    (MsgID:    WM_COALESCE_FIRST { $0390 };
     MsgDesc: 'WM_COALESCE_FIRST'),
    (MsgID:    WM_COALESCE_LAST { $039F };
     MsgDesc: 'WM_COALESCE_LAST'),
    (MsgID:    WM_DDE_INITIATE { WM_DDE_FIRST + 0 };
     MsgDesc: 'WM_DDE_INITIATE' {WM_DDE_FIRST}),
    (MsgID:    WM_DDE_TERMINATE { WM_DDE_FIRST + 1 };
     MsgDesc: 'WM_DDE_TERMINATE'),
    (MsgID:    WM_DDE_ADVISE { WM_DDE_FIRST + 2 };
     MsgDesc: 'WM_DDE_ADVISE'),
    (MsgID:    WM_DDE_UNADVISE { WM_DDE_FIRST + 3 };
     MsgDesc: 'WM_DDE_UNADVISE'),
    (MsgID:    WM_DDE_ACK { WM_DDE_FIRST + 4 };
     MsgDesc: 'WM_DDE_ACK'),
    (MsgID:    WM_DDE_DATA { WM_DDE_FIRST + 5 };
     MsgDesc: 'WM_DDE_DATA'),
    (MsgID:    WM_DDE_REQUEST { WM_DDE_FIRST + 6 };
     MsgDesc: 'WM_DDE_REQUEST'),
    (MsgID:    WM_DDE_POKE { WM_DDE_FIRST + 7 };
     MsgDesc: 'WM_DDE_POKE'),
    (MsgID:    WM_DDE_EXECUTE { WM_DDE_FIRST + 8 };
     MsgDesc: 'WM_DDE_EXECUTE' {WM_DDE_LAST}),
    (MsgID:    WM_APP { $8000 };
     MsgDesc: 'CM_BASE'),
    (MsgID:    CM_BASE { $B000 };
     MsgDesc: 'WM_APP'),
    (MsgID:    CM_ACTIVATE { CM_BASE + 0 };
     MsgDesc: 'CM_ACTIVATE'),
    (MsgID:    CM_DEACTIVATE { CM_BASE + 1 };
     MsgDesc: 'CM_DEACTIVATE'),
    (MsgID:    CM_GOTFOCUS { CM_BASE + 2 };
     MsgDesc: 'CM_GOTFOCUS'),
    (MsgID:    CM_LOSTFOCUS { CM_BASE + 3 };
     MsgDesc: 'CM_LOSTFOCUS'),
    (MsgID:    CM_CANCELMODE { CM_BASE + 4 };
     MsgDesc: 'CM_CANCELMODE'),
    (MsgID:    CM_DIALOGKEY { CM_BASE + 5 };
     MsgDesc: 'CM_DIALOGKEY'),
    (MsgID:    CM_DIALOGCHAR { CM_BASE + 6 };
     MsgDesc: 'CM_DIALOGCHAR'),
    (MsgID:    CM_FOCUSCHANGED { CM_BASE + 7 };
     MsgDesc: 'CM_FOCUSCHANGED'),
    (MsgID:    CM_PARENTFONTCHANGED { CM_BASE + 8 };
     MsgDesc: 'CM_PARENTFONTCHANGED'),
    (MsgID:    CM_PARENTCOLORCHANGED { CM_BASE + 9 };
     MsgDesc: 'CM_PARENTCOLORCHANGED'),
    (MsgID:    CM_HITTEST { CM_BASE + 10 };
     MsgDesc: 'CM_HITTEST'),
    (MsgID:    CM_VISIBLECHANGED { CM_BASE + 11 };
     MsgDesc: 'CM_VISIBLECHANGED'),
    (MsgID:    CM_ENABLEDCHANGED { CM_BASE + 12 };
     MsgDesc: 'CM_ENABLEDCHANGED'),
    (MsgID:    CM_COLORCHANGED { CM_BASE + 13 };
     MsgDesc: 'CM_COLORCHANGED'),
    (MsgID:    CM_FONTCHANGED { CM_BASE + 14 };
     MsgDesc: 'CM_FONTCHANGED'),
    (MsgID:    CM_CURSORCHANGED { CM_BASE + 15 };
     MsgDesc: 'CM_CURSORCHANGED'),
    (MsgID:    CM_CTL3DCHANGED { CM_BASE + 16 };
     MsgDesc: 'CM_CTL3DCHANGED'),
    (MsgID:    CM_PARENTCTL3DCHANGED { CM_BASE + 17 };
     MsgDesc: 'CM_PARENTCTL3DCHANGED'),
    (MsgID:    CM_TEXTCHANGED { CM_BASE + 18 };
     MsgDesc: 'CM_TEXTCHANGED'),
    (MsgID:    CM_MOUSEENTER { CM_BASE + 19 };
     MsgDesc: 'CM_MOUSEENTER'),
    (MsgID:    CM_MOUSELEAVE { CM_BASE + 20 };
     MsgDesc: 'CM_MOUSELEAVE'),
    (MsgID:    CM_MENUCHANGED { CM_BASE + 21 };
     MsgDesc: 'CM_MENUCHANGED'),
    (MsgID:    CM_APPKEYDOWN { CM_BASE + 22 };
     MsgDesc: 'CM_APPKEYDOWN'),
    (MsgID:    CM_APPSYSCOMMAND { CM_BASE + 23 };
     MsgDesc: 'CM_APPSYSCOMMAND'),
    (MsgID:    CM_BUTTONPRESSED { CM_BASE + 24 };
     MsgDesc: 'CM_BUTTONPRESSED'),
    (MsgID:    CM_SHOWINGCHANGED { CM_BASE + 25 };
     MsgDesc: 'CM_SHOWINGCHANGED'),
    (MsgID:    CM_ENTER { CM_BASE + 26 };
     MsgDesc: 'CM_ENTER'),
    (MsgID:    CM_EXIT { CM_BASE + 27 };
     MsgDesc: 'CM_EXIT'),
    (MsgID:    CM_DESIGNHITTEST { CM_BASE + 28 };
     MsgDesc: 'CM_DESIGNHITTEST'),
    (MsgID:    CM_ICONCHANGED { CM_BASE + 29 };
     MsgDesc: 'CM_ICONCHANGED'),
    (MsgID:    CM_WANTSPECIALKEY { CM_BASE + 30 };
     MsgDesc: 'CM_WANTSPECIALKEY'),
    (MsgID:    CM_INVOKEHELP { CM_BASE + 31 };
     MsgDesc: 'CM_INVOKEHELP'),
    (MsgID:    CM_WINDOWHOOK { CM_BASE + 32 };
     MsgDesc: 'CM_WINDOWHOOK'),
    (MsgID:    CM_RELEASE { CM_BASE + 33 };
     MsgDesc: 'CM_RELEASE'),
    (MsgID:    CM_SHOWHINTCHANGED { CM_BASE + 34 };
     MsgDesc: 'CM_SHOWHINTCHANGED'),
    (MsgID:    CM_PARENTSHOWHINTCHANGED { CM_BASE + 35 };
     MsgDesc: 'CM_PARENTSHOWHINTCHANGED'),
    (MsgID:    CM_SYSCOLORCHANGE { CM_BASE + 36 };
     MsgDesc: 'CM_SYSCOLORCHANGE'),
    (MsgID:    CM_WININICHANGE { CM_BASE + 37 };
     MsgDesc: 'CM_WININICHANGE'),
    (MsgID:    CM_FONTCHANGE { CM_BASE + 38 };
     MsgDesc: 'CM_FONTCHANGE'),
    (MsgID:    CM_TIMECHANGE { CM_BASE + 39 };
     MsgDesc: 'CM_TIMECHANGE'),
    (MsgID:    CM_TABSTOPCHANGED { CM_BASE + 40 };
     MsgDesc: 'CM_TABSTOPCHANGED'),
    (MsgID:    CM_UIACTIVATE { CM_BASE + 41 };
     MsgDesc: 'CM_UIACTIVATE'),
    (MsgID:    CM_UIDEACTIVATE { CM_BASE + 42 };
     MsgDesc: 'CM_UIDEACTIVATE'),
    (MsgID:    CM_DOCWINDOWACTIVATE { CM_BASE + 43 };
     MsgDesc: 'CM_DOCWINDOWACTIVATE'),
    (MsgID:    CM_CONTROLLISTCHANGE { CM_BASE + 44 };
     MsgDesc: 'CM_CONTROLLISTCHANGE'),
    (MsgID:    CM_GETDATALINK { CM_BASE + 45 };
     MsgDesc: 'CM_GETDATALINK'),
    (MsgID:    CM_CHILDKEY { CM_BASE + 46 };
     MsgDesc: 'CM_CHILDKEY'),
    (MsgID:    CM_DRAG { CM_BASE + 47 };
     MsgDesc: 'CM_DRAG'),
    (MsgID:    CM_HINTSHOW { CM_BASE + 48 };
     MsgDesc: 'CM_HINTSHOW'),
    (MsgID:    CM_DIALOGHANDLE { CM_BASE + 49 };
     MsgDesc: 'CM_DIALOGHANDLE'),
    (MsgID:    CM_ISTOOLCONTROL { CM_BASE + 50 };
     MsgDesc: 'CM_ISTOOLCONTROL'),
    (MsgID:    CM_RECREATEWND { CM_BASE + 51 };
     MsgDesc: 'CM_RECREATEWND'),
    (MsgID:    CM_INVALIDATE { CM_BASE + 52 };
     MsgDesc: 'CM_INVALIDATE'),
    (MsgID:    CM_SYSFONTCHANGED { CM_BASE + 53 };
     MsgDesc: 'CM_SYSFONTCHANGED'),
    (MsgID:    CM_CONTROLCHANGE { CM_BASE + 54 };
     MsgDesc: 'CM_CONTROLCHANGE'),
    (MsgID:    CM_CHANGED { CM_BASE + 55 };
     MsgDesc: 'CM_CHANGED'),
    (MsgID:    CM_DOCKCLIENT { CM_BASE + 56 };
     MsgDesc: 'CM_DOCKCLIENT'),
    (MsgID:    CM_UNDOCKCLIENT { CM_BASE + 57 };
     MsgDesc: 'CM_UNDOCKCLIENT'),
    (MsgID:    CM_FLOAT { CM_BASE + 58 };
     MsgDesc: 'CM_FLOAT'),
    (MsgID:    CM_BORDERCHANGED { CM_BASE + 59 };
     MsgDesc: 'CM_BORDERCHANGED'),
    (MsgID:    CM_BIDIMODECHANGED { CM_BASE + 60 };
     MsgDesc: 'CM_BIDIMODECHANGED'),
    (MsgID:    CM_PARENTBIDIMODECHANGED { CM_BASE + 61 };
     MsgDesc: 'CM_PARENTBIDIMODECHANGED'),
    (MsgID:    CM_ALLCHILDRENFLIPPED { CM_BASE + 62 };
     MsgDesc: 'CM_ALLCHILDRENFLIPPED'),
    (MsgID:    CM_ACTIONUPDATE { CM_BASE + 63 };
     MsgDesc: 'CM_ACTIONUPDATE'),
    (MsgID:    CM_ACTIONEXECUTE { CM_BASE + 64 };
     MsgDesc: 'CM_ACTIONEXECUTE'),
    (MsgID:    CM_HINTSHOWPAUSE { CM_BASE + 65 };
     MsgDesc: 'CM_HINTSHOWPAUSE'),
    (MsgID:    CM_DOCKNOTIFICATION { CM_BASE + 66 };
     MsgDesc: 'CM_DOCKNOTIFICATION'),
    (MsgID:    CM_MOUSEWHEEL { CM_BASE + 67 };
     MsgDesc: 'CM_MOUSEWHEEL'),
    (MsgID:    CM_ISSHORTCUT { CM_BASE + 68 };
     MsgDesc: 'CM_ISSHORTCUT'),
    (MsgID:    CN_BASE { $BC00 };
     MsgDesc: 'CN_BASE'),
    (MsgID:    CN_CHARTOITEM { CN_BASE + WM_CHARTOITEM };
     MsgDesc: 'CN_CHARTOITEM'),
    (MsgID:    CN_COMMAND { CN_BASE + WM_COMMAND };
     MsgDesc: 'CN_COMMAND'),
    (MsgID:    CN_COMPAREITEM { CN_BASE + WM_COMPAREITEM };
     MsgDesc: 'CN_COMPAREITEM'),
    (MsgID:    CN_CTLCOLORBTN { CN_BASE + WM_CTLCOLORBTN };
     MsgDesc: 'CN_CTLCOLORBTN'),
    (MsgID:    CN_CTLCOLORDLG { CN_BASE + WM_CTLCOLORDLG };
     MsgDesc: 'CN_CTLCOLORDLG'),
    (MsgID:    CN_CTLCOLOREDIT { CN_BASE + WM_CTLCOLOREDIT };
     MsgDesc: 'CN_CTLCOLOREDIT'),
    (MsgID:    CN_CTLCOLORLISTBOX { CN_BASE + WM_CTLCOLORLISTBOX };
     MsgDesc: 'CN_CTLCOLORLISTBOX'),
    (MsgID:    CN_CTLCOLORMSGBOX { CN_BASE + WM_CTLCOLORMSGBOX };
     MsgDesc: 'CN_CTLCOLORMSGBOX'),
    (MsgID:    CN_CTLCOLORSCROLLBAR { CN_BASE + WM_CTLCOLORSCROLLBAR };
     MsgDesc: 'CN_CTLCOLORSCROLLBAR'),
    (MsgID:    CN_CTLCOLORSTATIC { CN_BASE + WM_CTLCOLORSTATIC };
     MsgDesc: 'CN_CTLCOLORSTATIC'),
    (MsgID:    CN_DELETEITEM { CN_BASE + WM_DELETEITEM };
     MsgDesc: 'CN_DELETEITEM'),
    (MsgID:    CN_DRAWITEM { CN_BASE + WM_DRAWITEM };
     MsgDesc: 'CN_DRAWITEM'),
    (MsgID:    CN_HSCROLL { CN_BASE + WM_HSCROLL };
     MsgDesc: 'CN_HSCROLL'),
    (MsgID:    CN_MEASUREITEM { CN_BASE + WM_MEASUREITEM };
     MsgDesc: 'CN_MEASUREITEM'),
    (MsgID:    CN_PARENTNOTIFY { CN_BASE + WM_PARENTNOTIFY };
     MsgDesc: 'CN_PARENTNOTIFY'),
    (MsgID:    CN_VKEYTOITEM { CN_BASE + WM_VKEYTOITEM };
     MsgDesc: 'CN_VKEYTOITEM'),
    (MsgID:    CN_VSCROLL { CN_BASE + WM_VSCROLL };
     MsgDesc: 'CN_VSCROLL'),
    (MsgID:    CN_KEYDOWN { CN_BASE + WM_KEYDOWN };
     MsgDesc: 'CN_KEYDOWN'),
    (MsgID:    CN_KEYUP { CN_BASE + WM_KEYUP };
     MsgDesc: 'CN_KEYUP'),
    (MsgID:    CN_CHAR { CN_BASE + WM_CHAR };
     MsgDesc: 'CN_CHAR'),
    (MsgID:    CN_SYSKEYDOWN { CN_BASE + WM_SYSKEYDOWN };
     MsgDesc: 'CN_SYSKEYDOWN'),
    (MsgID:    CN_SYSCHAR { CN_BASE + WM_SYSCHAR };
     MsgDesc: 'CN_SYSCHAR'),
    (MsgID:    CN_NOTIFY { CN_BASE + WM_NOTIFY };
     MsgDesc: 'CN_NOTIFY')
  );

function MsgIDToStr(MsgID: Word): String;
var
  I: Integer;
begin
  for I := Low(Messages) to High(Messages) do
    if Messages[I].MsgID = MsgID then
    begin
      Result := Messages[I].MsgDesc;
      Exit
    end;
  //Since the data type is Word, the 2nd test here is redundant
  if (MsgID >= $C000) {and (MsgID <= $FFFF)} then
    Result := Format('Reg. msg. ($%.4x)', [MsgID - WM_APP])
  else
  if MsgID > CN_BASE then
    Result := Format('CN_BASE + $%.4x', [MsgID - CN_BASE])
  else
  if MsgID > CM_BASE then
    Result := Format('CM_BASE + $%.4x', [MsgID - CM_BASE])
  else
  if MsgID > WM_APP then
    Result := Format('WM_APP + $%.4x', [MsgID - WM_APP])
  else
  if MsgID > WM_USER then
    Result := Format('WM_USER + $%.4x', [MsgID - WM_USER])
  else
    Result := Format('$%.4x', [MsgID])
end;

end.
