unit WindowProcTraceAndNotificationResponseU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ButtonEx2, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Lst: TListView;
    Panel1: TPanel;
    chkWndProcHooked: TCheckBox;
    ButtonEx2: TButtonEx2;
    procedure chkWndProcHookedClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonEx2Message(Sender: TComponent; var Msg: TMessage);
    procedure ButtonEx2ClickNotification(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses MessageIDs;

{$R *.dfm}

procedure TForm1.chkWndProcHookedClick(Sender: TObject);
begin
  if chkWndProcHooked.Checked then
    ButtonEx2.OnMessage := ButtonEx2Message
  else
    ButtonEx2.OnMessage := nil
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ButtonEx2.OnMessage := nil
end;

procedure TForm1.ButtonEx2Message(Sender: TComponent; var Msg: TMessage);
var
  Item: TListItem;
begin
  Item := Lst.Items.Add;
  Item.Caption := MsgIDToStr(Msg.Msg);
  Item.SubItems.Add(Format('$%x (%0:d)', [Msg.WParam]));
  Item.SubItems.Add(Format('$%x (%0:d)', [Msg.LParam]));
  Item.SubItems.Add(FormatDateTime('h:nn:ss.zzz', Time));
  Item.Selected := True;
  Item.Focused := True;
  Item.MakeVisible(False)
end;

procedure TForm1.ButtonEx2ClickNotification(Sender: TObject);
begin
  ShowMessage('A click notification message has been received')
end;

end.
